diff --git a/include/configs/MigoR.h b/include/configs/MigoR.h
index cd10372..3cf2f09 100644
--- a/include/configs/MigoR.h
+++ b/include/configs/MigoR.h
@@ -27,7 +27,6 @@
 #define CONFIG_SYS_TEXT_BASE	0x8FFC0000
 #define CONFIG_SYS_LONGHELP			/* undef to save memory	*/
 #define CONFIG_SYS_PBSIZE		256		/* Buffer size for Console output */
-#define CONFIG_SYS_BARGSIZE	512		/* Buffer size for Boot Arguments passed to kernel */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }	/* List of legal baudrate settings for this board */
 
 /* SCIF */
diff --git a/include/configs/ap325rxa.h b/include/configs/ap325rxa.h
index c63913a..1140a70 100644
--- a/include/configs/ap325rxa.h
+++ b/include/configs/ap325rxa.h
@@ -33,8 +33,6 @@
 /* Monitor Command Prompt */
 /* Buffer size for Console output */
 #define CONFIG_SYS_PBSIZE		256
-/* Buffer size for Boot Arguments passed to kernel */
-#define CONFIG_SYS_BARGSIZE	512
 /* List of legal baudrate settings for this board */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 38400 }
 
diff --git a/include/configs/ap_sh4a_4a.h b/include/configs/ap_sh4a_4a.h
index 8acaee1..ab3d40c 100644
--- a/include/configs/ap_sh4a_4a.h
+++ b/include/configs/ap_sh4a_4a.h
@@ -33,8 +33,6 @@
 /* Monitor Command Prompt */
 /* Buffer size for Console output */
 #define CONFIG_SYS_PBSIZE		256
-/* Buffer size for Boot Arguments passed to kernel */
-#define CONFIG_SYS_BARGSIZE	512
 /* List of legal baudrate settings for this board */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
diff --git a/include/configs/armadillo-800eva.h b/include/configs/armadillo-800eva.h
index bea1e72..66ae76b 100644
--- a/include/configs/armadillo-800eva.h
+++ b/include/configs/armadillo-800eva.h
@@ -36,7 +36,6 @@
 
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE		512
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
 /* SCIF */
diff --git a/include/configs/ecovec.h b/include/configs/ecovec.h
index 8c8f68f..8cb3efc 100644
--- a/include/configs/ecovec.h
+++ b/include/configs/ecovec.h
@@ -66,8 +66,6 @@
 /* Monitor Command Prompt */
 /* Buffer size for Console output */
 #define CONFIG_SYS_PBSIZE		256
-/* Buffer size for Boot Arguments passed to kernel */
-#define CONFIG_SYS_BARGSIZE	512
 /* List of legal baudrate settings for this board */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
diff --git a/include/configs/espt.h b/include/configs/espt.h
index 934b52a..628406a 100644
--- a/include/configs/espt.h
+++ b/include/configs/espt.h
@@ -25,8 +25,6 @@
 #define CONFIG_SYS_TEXT_BASE	0x8FFC0000
 #define CONFIG_SYS_LONGHELP		/* undef to save memory */
 #define CONFIG_SYS_PBSIZE		256	/* Buffer size for Console output */
-#define CONFIG_SYS_BARGSIZE	512	/* Buffer size for Boot Arguments
-								passed to kernel */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }	/* List of legal baudrate
 												settings for this board */
 
diff --git a/include/configs/kzm9g.h b/include/configs/kzm9g.h
index b408cd4..a260d0e 100644
--- a/include/configs/kzm9g.h
+++ b/include/configs/kzm9g.h
@@ -41,7 +41,6 @@
 /* prompt */
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE		512
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
 /* SCIF */
diff --git a/include/configs/mpr2.h b/include/configs/mpr2.h
index 761558c..14b0492 100644
--- a/include/configs/mpr2.h
+++ b/include/configs/mpr2.h
@@ -24,7 +24,6 @@
 
 /* U-Boot internals */
 #define CONFIG_SYS_LONGHELP			/* undef to save memory	*/
-#define CONFIG_SYS_BARGSIZE		512	/* Buffer size for Boot Arguments passed to kernel */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }	/* List of legal baudrate settings for this board */
 #define CONFIG_SYS_LOAD_ADDR		(CONFIG_SYS_SDRAM_BASE + 32 * 1024 * 1024)
 #define CONFIG_SYS_MONITOR_BASE	CONFIG_SYS_FLASH_BASE
diff --git a/include/configs/ms7720se.h b/include/configs/ms7720se.h
index 19cbe86..7a9aa82 100644
--- a/include/configs/ms7720se.h
+++ b/include/configs/ms7720se.h
@@ -26,8 +26,6 @@
 #define CONFIG_SYS_TEXT_BASE	0x8FFC0000
 #define CONFIG_SYS_LONGHELP		/* undef to save memory	*/
 #define CONFIG_SYS_PBSIZE	256	/* Buffer size for Console output */
-/* Buffer size for Boot Arguments passed to kernel */
-#define CONFIG_SYS_BARGSIZE	512
 /* List of legal baudrate settings for this board */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
diff --git a/include/configs/ms7722se.h b/include/configs/ms7722se.h
index ca9fcd4..431d747 100644
--- a/include/configs/ms7722se.h
+++ b/include/configs/ms7722se.h
@@ -27,7 +27,6 @@
 #define CONFIG_SYS_TEXT_BASE	0x8FFC0000
 #define CONFIG_SYS_LONGHELP				/* undef to save memory	*/
 #define CONFIG_SYS_PBSIZE		256		/* Buffer size for Console output */
-#define CONFIG_SYS_BARGSIZE		512		/* Buffer size for Boot Arguments passed to kernel */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }	/* List of legal baudrate settings for this board */
 
 /* SCIF */
diff --git a/include/configs/ms7750se.h b/include/configs/ms7750se.h
index f67912d..e942758 100644
--- a/include/configs/ms7750se.h
+++ b/include/configs/ms7750se.h
@@ -30,7 +30,6 @@
 
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE		512
 
 #define CONFIG_SYS_TEXT_BASE		0x8FFC0000
 #define CONFIG_SYS_MEMTEST_START	(CONFIG_SYS_SDRAM_BASE)
diff --git a/include/configs/r0p7734.h b/include/configs/r0p7734.h
index 1550976..ea9aa8d 100644
--- a/include/configs/r0p7734.h
+++ b/include/configs/r0p7734.h
@@ -36,8 +36,6 @@
 
 /* undef to save memory	*/
 #define CONFIG_SYS_LONGHELP
-/* Buffer size for Boot Arguments passed to kernel */
-#define CONFIG_SYS_BARGSIZE	512
 /* List of legal baudrate settings for this board */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
diff --git a/include/configs/r2dplus.h b/include/configs/r2dplus.h
index 5728ef0..cdbe96e 100644
--- a/include/configs/r2dplus.h
+++ b/include/configs/r2dplus.h
@@ -20,7 +20,6 @@
 #define CONFIG_SYS_TEXT_BASE		0x8FE00000
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE		512
 
 #define CONFIG_SYS_MEMTEST_START	(CONFIG_SYS_SDRAM_BASE)
 #define CONFIG_SYS_MEMTEST_END		(CONFIG_SYS_TEXT_BASE - 0x100000)
diff --git a/include/configs/r7780mp.h b/include/configs/r7780mp.h
index 857fc10..241d067 100644
--- a/include/configs/r7780mp.h
+++ b/include/configs/r7780mp.h
@@ -27,7 +27,6 @@
 
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE	512
 
 #define CONFIG_SYS_MEMTEST_START	(CONFIG_SYS_SDRAM_BASE)
 #define CONFIG_SYS_MEMTEST_END		(CONFIG_SYS_TEXT_BASE - 0x100000)
diff --git a/include/configs/rcar-gen2-common.h b/include/configs/rcar-gen2-common.h
index a137ac4..2c10e61 100644
--- a/include/configs/rcar-gen2-common.h
+++ b/include/configs/rcar-gen2-common.h
@@ -32,7 +32,6 @@
 
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE		512
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 38400, 115200 }
 
 #define CONFIG_SYS_SDRAM_BASE		(RCAR_GEN2_SDRAM_BASE)
diff --git a/include/configs/rsk7203.h b/include/configs/rsk7203.h
index 2f84746..e52756a 100644
--- a/include/configs/rsk7203.h
+++ b/include/configs/rsk7203.h
@@ -25,8 +25,6 @@
 
 #define CONFIG_SYS_TEXT_BASE	0x0C7C0000
 #define CONFIG_SYS_LONGHELP		/* undef to save memory	*/
-/* Buffer size for Boot Arguments passed to kernel */
-#define CONFIG_SYS_BARGSIZE	512
 /* List of legal baudrate settings for this board */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
diff --git a/include/configs/sh7752evb.h b/include/configs/sh7752evb.h
index 52ed06f..13d22a2 100644
--- a/include/configs/sh7752evb.h
+++ b/include/configs/sh7752evb.h
@@ -25,7 +25,6 @@
 
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE		512
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
 /* SCIF */
diff --git a/include/configs/sh7753evb.h b/include/configs/sh7753evb.h
index b97e403..66f8c7a 100644
--- a/include/configs/sh7753evb.h
+++ b/include/configs/sh7753evb.h
@@ -25,7 +25,6 @@
 
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE		512
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
 /* SCIF */
diff --git a/include/configs/sh7757lcr.h b/include/configs/sh7757lcr.h
index 0c0a669..43de7e5 100644
--- a/include/configs/sh7757lcr.h
+++ b/include/configs/sh7757lcr.h
@@ -26,7 +26,6 @@
 
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE		512
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
 /* SCIF */
diff --git a/include/configs/sh7763rdp.h b/include/configs/sh7763rdp.h
index 00f3576..61fb64e 100644
--- a/include/configs/sh7763rdp.h
+++ b/include/configs/sh7763rdp.h
@@ -25,8 +25,6 @@
 #define CONFIG_SYS_TEXT_BASE	0x8FFC0000
 #define CONFIG_SYS_LONGHELP		/* undef to save memory */
 #define CONFIG_SYS_PBSIZE		256	/* Buffer size for Console output */
-#define CONFIG_SYS_BARGSIZE	512	/* Buffer size for Boot Arguments
-								passed to kernel */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }	/* List of legal baudrate
 												settings for this board */
 
diff --git a/include/configs/sh7785lcr.h b/include/configs/sh7785lcr.h
index 8ad83d8..f77e47a 100644
--- a/include/configs/sh7785lcr.h
+++ b/include/configs/sh7785lcr.h
@@ -41,7 +41,6 @@
 
 #define CONFIG_SYS_LONGHELP
 #define CONFIG_SYS_PBSIZE		256
-#define CONFIG_SYS_BARGSIZE		512
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 115200 }
 
 /* SCIF */
diff --git a/include/configs/shmin.h b/include/configs/shmin.h
index c5eacc6..1a69303 100644
--- a/include/configs/shmin.h
+++ b/include/configs/shmin.h
@@ -29,8 +29,6 @@
 #define CONFIG_SYS_TEXT_BASE	0x8DFB0000
 #define CONFIG_SYS_LONGHELP		/* undef to save memory	*/
 #define CONFIG_SYS_PBSIZE	256	/* Buffer size for Console output */
-/* Buffer size for Boot Arguments passed to kernel */
-#define CONFIG_SYS_BARGSIZE	512
 /* List of legal baudrate settings for this board */
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 9600,14400,19200,38400,57600,115200 }
 